<?php

namespace App\Policies;

use App\Models\DigitalPayment;
use App\Models\User;

class DigitalPaymentPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return true;
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, DigitalPayment $digitalPayment): bool
    {
        return $user->isSuperAdmin() || $user->id === $digitalPayment->user_id;
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return true;
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, DigitalPayment $digitalPayment): bool
    {
        return $user->isSuperAdmin() || $user->id === $digitalPayment->user_id;
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, DigitalPayment $digitalPayment): bool
    {
        return $user->isSuperAdmin() || $user->id === $digitalPayment->user_id;
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, DigitalPayment $digitalPayment): bool
    {
        return false;
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, DigitalPayment $digitalPayment): bool
    {
        return false;
    }
}
